#line 1 "C:/Users/user/Desktop/MICROCONTROLLERS/micro-c-files/I2Cexample.c"
volatile char date[10];
volatile char time[10];


unsigned char getd(unsigned char nn)
{
 return ((nn & 0xF0)>>4)+0x30;
}

unsigned char getu(unsigned char nn)
{
 return (nn & 0x0F)+0x30;
}

 void main(){

 char *text;
 char mem_data;
 unsigned char tmp;
 unsigned i;

 PORTB = 0;
 TRISB = 0;

 Lcd8_Config(&PORTE, &PORTD, 2,1,0,7,6, 5, 4, 3, 2, 1, 0);
 LCD8_Cmd(LCD_CURSOR_OFF);
 LCD8_Cmd(LCD_CLEAR);

 text = "I2C EEPROM DEMO";
 LCD8_Out(1,1,text);


 Soft_I2C_Config(&PORTC, 4, 3);


 Soft_I2C_Start();

 Soft_I2C_Write(0xA2);
 Soft_I2C_Write(2);
 Soft_I2C_Write('N');
 Soft_I2C_Write('i');
 Soft_I2C_Write('k');
 Soft_I2C_Write('o');
 Soft_I2C_Write('s');

 Soft_I2C_Stop();

 Delay_ms(100);


 Soft_I2C_Start();
 Soft_I2C_Write(0xA2);
 Soft_I2C_Write(2);


 Soft_I2C_Start();
 Soft_I2C_Write(0xA3);
 for (i=0;i<5;i++) {
 mem_data = Soft_I2C_Read(0);
 Lcd8_Chr(2,i+1, mem_data);
 }

 Soft_I2C_Stop();


 delay_ms(3000);




 Soft_I2C_Start();
 Soft_I2C_Write(0xD0);
 Soft_I2C_Write(0);

 Soft_I2C_Start();
 Soft_I2C_Write(0xD1);
 tmp= 0x7F & Soft_I2C_Read(1);
 time[5]=':';
 time[6]=getd(tmp);
 time[7]=getu(tmp);
 time[8]=0;

 tmp= 0x7F & Soft_I2C_Read(1);
 time[2]=':';
 time[3]=getd(tmp);
 time[4]=getu(tmp);

 tmp= 0x3F & Soft_I2C_Read(1);
 time[0]=getd(tmp);
 time[1]=getu(tmp);


 Soft_I2C_Read(1);

 tmp= 0x3F & Soft_I2C_Read(1);
 date[0]=getd(tmp);
 date[1]=getu(tmp);


 tmp= 0x1F & Soft_I2C_Read(1);
 date[2]='/';
 date[3]=getd(tmp);
 date[4]=getu(tmp);

 tmp= Soft_I2C_Read(0);
 date[5]='/';
 date[6]=getd(tmp);
 date[7]=getu(tmp);
 date[8]=0;

 Soft_I2C_Stop();

 Lcd8_Out(1,1,time);
 Lcd8_out(2,1,date);




 while(1);



}
